// MULTILED.C
// Programmierung des Controllers Freescale MC68HC908, eingebaut in den Kamerablitz MPF-10 von Sony Ericsson
// Ersteller: Michael Gaus und Bernhard Kaiser
// 18.12.2006
// Funktionsumfang:
//	Konstantlicht, Dimmfunktion bei gedrckter Taste
//	Taste gedrckt bei Power_ON: Blinkfunktion mit steigender Frequenz bis hin zum Stroboskopeffekt


#include "mc68hc908qy.h"

#define LED_ON   {PTA4 = 1;}
#define LED_OFF  {PTA4 = 0;}
#define LED_pullup_off {PTAPUE4 = 0; } 
#define LED_output {DDRA4 = 1;} 

#define KEY_PRESSED  (PTA3==0)


enum { CONT, DIMMEN};

					

void main(void)
{
   #define DELAYTIME  25000 
   unsigned char near mode = CONT;			// Default: Dauerlicht bei Einschalten
   unsigned char near bKeyReleased = 1;			// "HilfsBit" fr Tastenabfrage
   unsigned long near i;
   unsigned long near j;
   unsigned long near waittime;
   unsigned long near waittime2;
   unsigned long near puls;
   unsigned long near pause;
   unsigned long near step;
   unsigned long near step2;				// Dimmbereich anpasssen
   unsigned long near counter;
   unsigned long near PWM;
   unsigned long near PWM_ON;
   unsigned long near frequenzwert;   
   waittime = 4000;					// Tastenverzgerung im UP Flashen
   waittime2 = 10;					// Faktor Tastenverzgerung im UP Dimmen in Verbindung mit counter
   puls = 30000;
   pause = 30000;
   step = 1000;	
   step2 = 15;						// in UP Flashen, Schrittweite wird bei hherer Frequenz  erniedrigt
   counter = 100;					// gedimmter Wert wird X-mal durchlaufen, bevor auf neuen Dimmwert umgestellt wird 
   PWM = 200;
   PWM_ON = 200;
   frequenzwert = 20000;

   CONFIG1 = 0x01;  // disable Watchdog
   CONFIG2 = 0x00;

   LED_pullup_off;
   LED_output;
   

   if(KEY_PRESSED)   // Flashfunktion wenn Taste bei PowerON gedrckt ist          ==========UP FLASHEN=======
	
    {
     for(i = 0; i < DELAYTIME; i++)			// Problem beim ersten Power_ON:Flashfunktion auch bei ungedrckter Taste
     {							// durch wiederholte Tastenabfrage gelst
     }		
      
      if(KEY_PRESSED) 
      {
    	   while(1)					// Tastverhltnis 2:1 Pause-Puls, Frequenz wird erhht
   	    {

  	       LED_ON;
  	   	 for(i = 0; i < puls; i++)  
  	   	 {
  	   	 }

   	      LED_OFF;
  	   	 for(i = 0; i < pause; i++)
  	   	 {
   	  	 }

   	  	 	if(KEY_PRESSED)
     		 	{
     		 	   frequenzwert = frequenzwert - step;

				 for(j = 0; j < waittime; j++)  // Warteschleife fr Tastenabfrage, bei hohen Frequenzen erforderlich, damit Bereiche nicht bersprungen werden
     				 {
     	 			 }
			         puls = frequenzwert;
			         pause = frequenzwert + frequenzwert;
		 

				 if (frequenzwert <= 15000)
					{
				        step = 500;
					}

				 if (frequenzwert <= 8000)
					{
				        step = 250;
					}
	
				 if (frequenzwert <= 4000)
					{
				        step = 150;
					}


				 if (frequenzwert <= 400)
					{
				         frequenzwert = 18000;
					 step = 1000;
					}
					
     			 }
      	      }
	}
    }


   while(1)
   {
      LED_ON;						// =========DAUERLICHT=============
      for(i = 0; i < DELAYTIME; i++)  
      {
      }

      if(mode == DIMMEN)				// ========== UP DIMMEN===========
      {
         
	  while(1)
	  {
	    pause = PWM - PWM_ON; 
	    LED_ON;
     	        for(i = 0; i < PWM_ON; i++)  		 
     	 	{
     	 	}
	    LED_OFF;
     	        for(i = 0; i < pause; i++)
     	        {
     	        }

	    if(KEY_PRESSED)
    	        {
    	    	  if (counter == 0)			// Nach Counter-Anzahl wird dimmwert verndert, ansonsten sofortige Dimmnderung
			{	
				PWM_ON = PWM_ON - step2;

		 		for(j = 0; j < waittime2; j++)  	// Warteschleife fr Tastenabfrage, bei hohen Frequenzen erforderlich, damit Bereiche nicht bersprungen werden
     		 		{
     	 	 		}
	    
		  		if (PWM_ON <= 100)	// je nach Helligkeitswert wird Schrittweite verringert
				{
		      		   step2 = 8;
				}

				if (PWM_ON <= 40)
				{
		      		   step2 = 3;
				}

				if (PWM_ON <= 10)
				{
		      		   step2 = 1;
				}

		  		if (PWM_ON <= 0)
				{			// nach Verzgerung werden Werte aufAnfangswert gesetzt
		      		   PWM_ON = 200;
				   step2 = 15;
				}
			
			        counter = 100;
			}

		  else
			{
			  counter = counter - 1;
			}

		}
          }

      }							// ==========Ende UP DIMMEN =============



      for(i = 0; i < DELAYTIME; i++)
      {
      }

      if(KEY_PRESSED)					// luft beim erstmaligen Drcken der Taste in diese Schleife und schaltet auf DiMMEN-mode um, 
      {
         if(bKeyReleased == 1)				// ursprngliches Programmteil von Michael
         {
            bKeyReleased = 0;
            if(mode == DIMMEN)
            {
               mode = CONT;
            }
            else
            {
               mode = DIMMEN;
            }

         }
      }
      else
      {
         bKeyReleased = 1;
      }
   }


}
