// MULTILED.C
// Programming of the controller Freescale MC68HC908, built-in mobile phone camera flash MPF-10 from Sony Ericsson
// Authors: Michael Gaus and Bernhard Kaiser
// 18.12.2006
// Functional range:
//	continuos light, dimming when key pressed
//	Key pressed at power-on: blinking with rising frequency up to strobe effect


#include "mc68hc908qy.h"

#define LED_ON   {PTA4 = 1;}
#define LED_OFF  {PTA4 = 0;}
#define LED_pullup_off {PTAPUE4 = 0; } 
#define LED_output {DDRA4 = 1;} 

#define KEY_PRESSED  (PTA3==0)


enum { CONT, DIMMEN};

					

void main(void)
{
   #define DELAYTIME  25000 
   unsigned char near mode = CONT;			// Default: continuos light at power-on
   unsigned char near bKeyReleased = 1;			// key checking
   unsigned long near i;
   unsigned long near j;
   unsigned long near waittime;
   unsigned long near waittime2;
   unsigned long near puls;
   unsigned long near pause;
   unsigned long near step;
   unsigned long near step2;				// adjust dimming range
   unsigned long near counter;
   unsigned long near PWM;
   unsigned long near PWM_ON;
   unsigned long near frequenzwert;   
   waittime = 4000;					// delaytime for keypressed
   waittime2 = 10;
   puls = 30000;
   pause = 30000;
   step = 1000;	
   step2 = 15;						// step size is decremented at higher frequency
   counter = 100;					// dim value is repeated X-times, before new dim value is set 
   PWM = 200;
   PWM_ON = 200;
   frequenzwert = 20000;

   CONFIG1 = 0x01;  // disable Watchdog
   CONFIG2 = 0x00;

   LED_pullup_off;
   LED_output;
   

   if(KEY_PRESSED)   // Flash function if key pressed at power-on          ==========FLASHING=======
	
    {
     for(i = 0; i < DELAYTIME; i++)
     {
     }		
      
      if(KEY_PRESSED) 
      {
    	   while(1)					// duty cycle 2:1 pause-pulse, frequency is incremented
   	    {

  	       LED_ON;
  	   	 for(i = 0; i < puls; i++)  
  	   	 {
  	   	 }

   	      LED_OFF;
  	   	 for(i = 0; i < pause; i++)
  	   	 {
   	  	 }

   	  	 	if(KEY_PRESSED)
     		 	{
     		 	   frequenzwert = frequenzwert - step;

				 for(j = 0; j < waittime; j++)  // delay loop before key checking, necessary at high frequencies
     				 {
     	 			 }
			         puls = frequenzwert;
			         pause = frequenzwert + frequenzwert;
		 

				 if (frequenzwert <= 15000)
					{
				        step = 500;
					}

				 if (frequenzwert <= 8000)
					{
				        step = 250;
					}
	
				 if (frequenzwert <= 4000)
					{
				        step = 150;
					}


				 if (frequenzwert <= 400)
					{
				         frequenzwert = 18000;
					 step = 1000;
					}
					
     			 }
      	      }
	}
    }


   while(1)
   {
      LED_ON;						// =========continuos light=============
      for(i = 0; i < DELAYTIME; i++)  
      {
      }

      if(mode == DIMMEN)				// ==========DIMMING===========
      {
         
	  while(1)
	  {
	    pause = PWM - PWM_ON; 
	    LED_ON;
     	        for(i = 0; i < PWM_ON; i++)  		 
     	 	{
     	 	}
	    LED_OFF;
     	        for(i = 0; i < pause; i++)
     	        {
     	        }

	    if(KEY_PRESSED)
    	        {
    	    	  if (counter == 0)			// change dim value if counter is zero
			{	
				PWM_ON = PWM_ON - step2;

		 		for(j = 0; j < waittime2; j++)  	// delay loop before key checking, necessary at high frequencies
     		 		{
     	 	 		}
	    
		  		if (PWM_ON <= 100)	// step size is decremented according to brightness value
				{
		      		   step2 = 8;
				}

				if (PWM_ON <= 40)
				{
		      		   step2 = 3;
				}

				if (PWM_ON <= 10)
				{
		      		   step2 = 1;
				}

		  		if (PWM_ON <= 0)
				{			// set default values after delay
		      		   PWM_ON = 200;
				   step2 = 15;
				}
			
			        counter = 100;
			}

		  else
			{
			  counter = counter - 1;
			}

		}
          }

      }							// ==========End DIMMING =============

      for(i = 0; i < DELAYTIME; i++)
      {
      }

      if(KEY_PRESSED)					// at first keypress switch to dim mode 
      {
         if(bKeyReleased == 1)
         {
            bKeyReleased = 0;
            if(mode == DIMMEN)
            {
               mode = CONT;
            }
            else
            {
               mode = DIMMEN;
            }

         }
      }
      else
      {
         bKeyReleased = 1;
      }
   }


}
